<?php if ( ! defined('BASEPATH')) exit('No direct script access allowed');

class Ws_model extends CI_Model{

/*default functions*/
public function common_fetch($table,$where){
	$this->db->where($where);
	$this->db->order_by('id','desc');
	$query = $this->db->get($table);
	return $query->result_array();
}
public function common_fetch_asc($table,$where){
	$this->db->where($where);
	$this->db->order_by('id','asc');
	$query = $this->db->get($table);
	return $query->result_array();
}
public function common_insert($table,$data){	
	$this->db->insert($table,$data);
	$id = $this->db->insert_id();
	return $id;
}
public function common_update($table,$data,$where){
	$this->db->where($where);
	$this->db->update($table,$data);
}
public function common_delete($table,$where){
	$this->db->where($where);
	$this->db->delete($table);
}
public function common_fetch_rows($table,$where){
	$this->db->where($where);	
	$query = $this->db->get($table);
	return $query->num_rows();
}
/*default functions*/

/*home page*/
public function get_vendors($data){
    $this->db->select("COALESCE(( 6371 * acos( cos( radians({$data['lat']}) ) * cos( radians( `lat` ) ) * cos( radians( lon ) - radians({$data['lon']}) ) + sin( radians({$data['lat']}) ) * sin( radians( `lat` ) ) ) ), 0) AS distance,sp.*", False);
    $this->db->from('storage_partners sp'); 
	//$this->db->where('vendor_id',$data['vendor_id']);
    $this->db->where('status',1);
	$this->db->where('to_date>',date('Y-m-d'));
    $this->db->order_by('distance','asc');
    $query = $this->db->get();
    return $query->result_array();
}
/*home page*/

/*pharmacy*/
public function get_pharmacy_main_data_first($lat, $lon, $radius, $limit, $offset){
    $this->db->select("
        COALESCE(( 6371 * acos( cos( radians({$lat}) ) * cos( radians( `lat` ) ) * cos( radians( lon ) - radians({$lon}) ) + sin( radians({$lat}) ) * sin( radians( `lat` ) ) ) ), 0) AS distance, 
        pharmacies.id,pharmacies.name,pharmacies.timings,pharmacies.logo,pharmacies.location,pharmacies.lat,pharmacies.lon", false);
    $this->db->from('pharmacies');
    
    // Filters
    $this->db->where('pharmacies.status', 1);
    $this->db->where('pharmacies.delete_status', 1);

    // Distance Filter
    $this->db->having('distance <=', $radius);

    // Grouping
    $this->db->group_by('pharmacies.id');
    $this->db->order_by('distance', 'asc');
    $this->db->limit($limit,$offset);
    $query = $this->db->get();
    $result = $query->result_array();

    
    return $result;
}
public function get_pharmacy_data_first_rows($lat, $lon, $radius){
    $this->db->select("
        COALESCE(( 6371 * acos( cos( radians({$lat}) ) * cos( radians( `lat` ) ) * cos( radians( lon ) - radians({$lon}) ) + sin( radians({$lat}) ) * sin( radians( `lat` ) ) ) ), 0) AS distance, 
        pharmacies.id,pharmacies.name,pharmacies.timings,pharmacies.logo,pharmacies.location,pharmacies.lat,pharmacies.lon", false);
    $this->db->from('pharmacies');
    
    // Filters
    $this->db->where('pharmacies.status', 1);
    $this->db->where('pharmacies.delete_status', 1);

    // Distance Filter
    $this->db->having('distance <=', $radius);

    // Grouping
    $this->db->group_by('pharmacies.id');
    $this->db->order_by('distance', 'asc');
    //$this->db->limit($limit,$offset);
    $query = $this->db->get();
    $result = $query->num_rows();

    
    return $result;
}
public function get_search_pharmacy_main_data_first($lat, $lon, $search, $radius) {
    $this->db->select("
        COALESCE(( 6371 * acos( cos( radians({$lat}) ) * cos( radians( `lat` ) ) * cos( radians( lon ) - radians({$lon}) ) + sin( radians({$lat}) ) * sin( radians( `lat` ) ) ) ), 0) AS distance, 
        pharmacies.id,pharmacies.name,pharmacies.timings,pharmacies.logo,pharmacies.location,pharmacies.lat,pharmacies.lon", false);
    $this->db->from('pharmacies');
    
    // Filters
    $this->db->where('pharmacies.status', 1);
    $this->db->where('pharmacies.delete_status', 1);
    $this->db->like('pharmacies.name',$search);

    // Distance Filter
    $this->db->having('distance <=', $radius);

    // Grouping
    $this->db->group_by('pharmacies.id');
    $this->db->order_by('distance', 'asc');

    $query = $this->db->get();
    $result = $query->result_array();
    
    return $result;

}
public function get_pharmacy_main_data($lat, $lon, $radius, $main_data_id) {
    $this->db->select("
        COALESCE(( 6371 * acos( cos( radians({$lat}) ) * cos( radians( `lat` ) ) * cos( radians( lon ) - radians({$lon}) ) + sin( radians({$lat}) ) * sin( radians( `lat` ) ) ) ), 0) AS distance, 
        pharmacies.*, 
        GROUP_CONCAT(DISTINCT img.image) AS images,
        GROUP_CONCAT(DISTINCT CONCAT(pharmacy_categories.id, '|', pharmacy_categories.name, '|', pharmacy_categories.image)) AS categories
    ", false); 
    
    $this->db->from('pharmacies');
    
    // Join images table
    $this->db->join('pharmacy_images img', 'img.main_data_id = pharmacies.id AND img.status=1 AND img.delete_status=1', 'left');
    $this->db->join('pharmacy_categories pharmacy_categories', 'pharmacy_categories.status=1 AND pharmacy_categories.delete_status=1', 'left');

    // Filters
    $this->db->where('pharmacies.id', $main_data_id);
    $this->db->where('pharmacies.status', 1);
    $this->db->where('pharmacies.delete_status', 1);

    // Distance Filter
    $this->db->having('distance <=', $radius);

    // Grouping & Sorting
    $this->db->group_by('pharmacies.id');
    $this->db->order_by('distance', 'asc');

    $query = $this->db->get();
    $result = $query->result_array();

    // Process the results using array_map
    return array_map(function ($row) {
        return [
            'id'          => intval($row['id']),
            'name'        => $row['name'],
            'mobile'      => intval($row['mobile']),
            'logo'        => $row['logo'],
            'open_time' => $row['open_time'],
            'close_time' => $row['close_time'],
            'location'    => $row['location'],
            'description' => $row['description'],
            'lat'         => $row['lat'],
            'lon'         => $row['lon'],
            'images'      => (!empty($row['images']) && is_string($row['images']))
                ? array_map(function ($image) {
                    return ['url' => trim($image)];
                }, array_filter(explode(',', $row['images'])))
                : [],
            'categories' => (!empty($row['categories']) && is_string($row['categories']))
                ? array_map(function ($speciality) {
                    list($id, $name, $image) = explode('|', $speciality);
                    return [
                        'id'    => intval($id),
                        'name'  => $name,
                        'image' => $image
                    ];
                }, array_filter(explode(',', $row['categories'])))
                : [],
        ];
    }, $result);
}
/*pharmacy*/

/*online_doctors*/
public function get_online_doctors($speciality_id) {
    $this->db->select('
        online_doctors.*, 
        SUM(online_doctor_ratings.rating) AS total_rating, 
        COUNT(online_doctor_ratings.id) AS total_reviews
    ')->from('online_doctors');

    $this->db->where([
        'online_doctors.speciality_id' => $speciality_id,
        'online_doctors.status' => 1,
        'online_doctors.delete_status' => 1
    ]);

    $this->db->join('online_doctor_ratings', 'online_doctor_ratings.doctor_id = online_doctors.id', 'left');
    
    $this->db->group_by('online_doctors.id');
    $this->db->order_by('online_doctors.id', 'desc');

    $query = $this->db->get();
    $result = $query->result_array(); 
    
    // Process the results using array_map
    return array_map(function ($row) {
        $total_rating = floatval($row['total_rating']);
        $total_reviews = intval($row['total_reviews']);
        $average_rating = ($total_reviews > 0) ? number_format($total_rating / $total_reviews, 1) : "0.0";

        return [
            'id'                => intval($row['id']),
            'unique_id'         => $row['unique_id'],
            'name'              => $row['name'],
            'image'             => $row['image'],
            'qualification'     => $row['qualification'],
            'specialization'    => $row['specialization'],
            'exp'               => $row['exp'],
            'description'       => $row['description'],
            'fee'               => intval($row['fee']),
            'rating'            => $average_rating,
            'total_reviews'     => $total_reviews
        ];
    }, $result);
}
/*online_doctors*/

/*lab_tests*/
public function get_lab_tests_main_data_first($lat, $lon, $radius, $limit, $offset){
    $this->db->select("
        COALESCE(( 6371 * acos( cos( radians({$lat}) ) * cos( radians( `lat` ) ) * cos( radians( lon ) - radians({$lon}) ) + sin( radians({$lat}) ) * sin( radians( `lat` ) ) ) ), 0) AS distance, 
        lab_tests.id,lab_tests.name,lab_tests.tagline,lab_tests.timings,lab_tests.logo,lab_tests.location,lab_tests.lat,lab_tests.lon", false);
    $this->db->from('lab_tests');
    
    // Filters
    $this->db->where('lab_tests.status', 1);
    $this->db->where('lab_tests.delete_status', 1);

    // Distance Filter
    $this->db->having('distance <=', $radius);

    // Grouping
    $this->db->group_by('lab_tests.id');
    $this->db->order_by('distance', 'asc');
    $this->db->limit($limit,$offset);
    $query = $this->db->get();
    $result = $query->result_array();

    
    return $result;
}
public function get_lab_tests_data_first_rows($lat, $lon, $radius){
    $this->db->select("
        COALESCE(( 6371 * acos( cos( radians({$lat}) ) * cos( radians( `lat` ) ) * cos( radians( lon ) - radians({$lon}) ) + sin( radians({$lat}) ) * sin( radians( `lat` ) ) ) ), 0) AS distance, 
        lab_tests.id,lab_tests.name,lab_tests.tagline,lab_tests.timings,lab_tests.logo,lab_tests.location,lab_tests.lat,lab_tests.lon", false);
    $this->db->from('lab_tests');
    
    // Filters
    $this->db->where('lab_tests.status', 1);
    $this->db->where('lab_tests.delete_status', 1);

    // Distance Filter
    $this->db->having('distance <=', $radius);

    // Grouping
    $this->db->group_by('lab_tests.id');
    $this->db->order_by('distance', 'asc');
    //$this->db->limit($limit,$offset);
    $query = $this->db->get();
    $result = $query->num_rows();

    
    return $result;
}
public function get_search_lab_tests_main_data_first($lat, $lon, $search, $radius) {
    $this->db->select("
        COALESCE(( 6371 * acos( cos( radians({$lat}) ) * cos( radians( `lat` ) ) * cos( radians( lon ) - radians({$lon}) ) + sin( radians({$lat}) ) * sin( radians( `lat` ) ) ) ), 0) AS distance, 
        lab_tests.id,lab_tests.name,lab_tests.tagline,lab_tests.timings,lab_tests.logo,lab_tests.location,lab_tests.lat,lab_tests.lon", false);
    $this->db->from('lab_tests');
    
    // Filters
    $this->db->where('lab_tests.status', 1);
    $this->db->where('lab_tests.delete_status', 1);
    $this->db->like('lab_tests.name',$search);

    // Distance Filter
    $this->db->having('distance <=', $radius);

    // Grouping
    $this->db->group_by('lab_tests.id');
    $this->db->order_by('distance', 'asc');

    $query = $this->db->get();
    $result = $query->result_array();
    
    return $result;

}
public function get_lab_tests_main_data($lat, $lon, $radius, $main_data_id) {
    $this->db->select("
        lab_test_packages.id,
        lab_test_packages.name,
        lab_test_packages.image,
        lab_test_packages.price,
        lab_test_packages.discount_price,
        lab_test_packages.report_in,
        lab_test_packages.fasting,
        tests.id AS test_id,
        tests.name AS test_name,
        sub_tests.id AS sub_test_id,
        sub_tests.name AS sub_test_name
    ");
    $this->db->from('lab_test_packages');
    $this->db->join('tests', 'tests.package_id = lab_test_packages.id AND tests.main_data_id = lab_test_packages.main_data_id AND tests.status = 1 AND tests.delete_status = 1', 'left');
    $this->db->join('sub_tests', 'sub_tests.test_id = tests.id AND sub_tests.package_id = tests.package_id AND sub_tests.main_data_id = tests.main_data_id AND sub_tests.status = 1 AND sub_tests.delete_status = 1', 'left');

    // Filters
    $this->db->where('lab_test_packages.main_data_id', $main_data_id);
    $this->db->where('lab_test_packages.status', 1);
    $this->db->where('lab_test_packages.delete_status', 1);
    
    $this->db->order_by('lab_test_packages.id', 'desc');

    $query = $this->db->get();
    $result = $query->result_array();

    // Process data to group tests & sub-tests properly
    $final_data = [];
    foreach ($result as $row) {
        $package_id = $row['id'];
        $test_id = $row['test_id'];
        $sub_test_id = $row['sub_test_id'];

        // Initialize package if not exists
        if (!isset($final_data[$package_id])) {
            $final_data[$package_id] = [
                'id' => intval($row['id']),
                'name' => $row['name'],
                'image' => $row['image'],
                'price' => intval($row['price']),
                'discount_price' => intval($row['discount_price']),
                'report_in' => $row['report_in'],
                'fasting' => $row['fasting'],
                'tests' => []
            ];
        }

        // Add test if not exists
        if ($test_id && !isset($final_data[$package_id]['tests'][$test_id])) {
            $final_data[$package_id]['tests'][$test_id] = [
                'id' => intval($test_id),
                'name' => $row['test_name'],
                'sub_tests' => []
            ];
        }

        // Add sub-test
        if ($sub_test_id) {
            $final_data[$package_id]['tests'][$test_id]['sub_tests'][] = [
                'id' => intval($sub_test_id),
                'name' => $row['sub_test_name']
            ];
        }
    }

    // Convert tests array from associative to indexed
    foreach ($final_data as &$package) {
        $package['tests'] = array_values($package['tests']);
    }

    return array_values($final_data);
}
/*lab_tests*/

/*diagnostics*/
public function get_diagnostics_main_data_first($lat, $lon, $radius, $limit, $offset){
    $this->db->select("
        COALESCE(( 6371 * acos( cos( radians({$lat}) ) * cos( radians( `lat` ) ) * cos( radians( lon ) - radians({$lon}) ) + sin( radians({$lat}) ) * sin( radians( `lat` ) ) ) ), 0) AS distance, 
        diagnostics.id,diagnostics.name,diagnostics.tagline,diagnostics.timings,diagnostics.logo,diagnostics.location,diagnostics.lat,diagnostics.lon", false);
    $this->db->from('diagnostics');
    
    // Filters
    $this->db->where('diagnostics.status', 1);
    $this->db->where('diagnostics.delete_status', 1);

    // Distance Filter
    $this->db->having('distance <=', $radius);

    // Grouping
    $this->db->group_by('diagnostics.id');
    $this->db->order_by('distance', 'asc');
    $this->db->limit($limit,$offset);
    $query = $this->db->get();
    $result = $query->result_array();

    
    return $result;
}
public function get_diagnostics_data_first_rows($lat, $lon, $radius){
    $this->db->select("
        COALESCE(( 6371 * acos( cos( radians({$lat}) ) * cos( radians( `lat` ) ) * cos( radians( lon ) - radians({$lon}) ) + sin( radians({$lat}) ) * sin( radians( `lat` ) ) ) ), 0) AS distance, 
        diagnostics.id,diagnostics.name,diagnostics.tagline,diagnostics.timings,diagnostics.logo,diagnostics.location,diagnostics.lat,diagnostics.lon", false);
    $this->db->from('diagnostics');
    
    // Filters
    $this->db->where('diagnostics.status', 1);
    $this->db->where('diagnostics.delete_status', 1);

    // Distance Filter
    $this->db->having('distance <=', $radius);

    // Grouping
    $this->db->group_by('diagnostics.id');
    $this->db->order_by('distance', 'asc');
    //$this->db->limit($limit,$offset);
    $query = $this->db->get();
    $result = $query->num_rows();

    return $result;
}
public function get_search_diagnostics_main_data_first($lat, $lon, $search, $radius) {
    $this->db->select("
        COALESCE(( 6371 * acos( cos( radians({$lat}) ) * cos( radians( `lat` ) ) * cos( radians( lon ) - radians({$lon}) ) + sin( radians({$lat}) ) * sin( radians( `lat` ) ) ) ), 0) AS distance, 
        diagnostics.id,diagnostics.name,diagnostics.tagline,diagnostics.timings,diagnostics.logo,diagnostics.location,diagnostics.lat,diagnostics.lon", false);
    $this->db->from('diagnostics');
    
    // Filters
    $this->db->where('diagnostics.status', 1);
    $this->db->where('diagnostics.delete_status', 1);
    $this->db->like('diagnostics.name',$search);

    // Distance Filter
    $this->db->having('distance <=', $radius);

    // Grouping
    $this->db->group_by('diagnostics.id');
    $this->db->order_by('distance', 'asc');

    $query = $this->db->get();
    $result = $query->result_array();
    
    return $result;
}
public function get_diagnostics_main_data($lat, $lon, $radius, $main_data_id) {
    $this->db->select("
        diagnostic_packages.id,
        diagnostic_packages.name,
        diagnostic_packages.image,
        diagnostic_packages.price,
        diagnostic_packages.discount_price,
        diagnostic_packages.report_in,
        diagnostic_packages.fasting,
        diagnostic_tests.id AS test_id,
        diagnostic_tests.name AS test_name,
        diagnostic_sub_tests.id AS sub_test_id,
        diagnostic_sub_tests.name AS sub_test_name
    ");
    $this->db->from('diagnostic_packages');
    $this->db->join('diagnostic_tests', 'diagnostic_tests.package_id = diagnostic_packages.id AND diagnostic_tests.main_data_id = diagnostic_packages.main_data_id AND diagnostic_tests.status = 1 AND diagnostic_tests.delete_status = 1', 'left');
    $this->db->join('diagnostic_sub_tests', 'diagnostic_sub_tests.test_id = diagnostic_tests.id AND diagnostic_sub_tests.package_id = diagnostic_tests.package_id AND diagnostic_sub_tests.main_data_id = diagnostic_tests.main_data_id AND diagnostic_sub_tests.status = 1 AND diagnostic_sub_tests.delete_status = 1', 'left');

    // Filters
    $this->db->where('diagnostic_packages.main_data_id', $main_data_id);
    $this->db->where('diagnostic_packages.status', 1);
    $this->db->where('diagnostic_packages.delete_status', 1);
    
    $this->db->order_by('diagnostic_packages.id', 'desc');

    $query = $this->db->get();
    $result = $query->result_array();

    // Process data to group tests & sub-tests properly
    $final_data = [];
    foreach ($result as $row) {
        $package_id = $row['id'];
        $test_id = $row['test_id'];
        $sub_test_id = $row['sub_test_id'];

        // Initialize package if not exists
        if (!isset($final_data[$package_id])) {
            $final_data[$package_id] = [
                'id' => intval($row['id']),
                'name' => $row['name'],
                'image' => $row['image'],
                'price' => intval($row['price']),
                'discount_price' => intval($row['discount_price']),
                'report_in' => $row['report_in'],
                'fasting' => $row['fasting'],
                'tests' => []
            ];
        }

        // Add test if not exists
        if ($test_id && !isset($final_data[$package_id]['tests'][$test_id])) {
            $final_data[$package_id]['tests'][$test_id] = [
                'id' => intval($test_id),
                'name' => $row['test_name'],
                'sub_tests' => []
            ];
        }

        // Add sub-test
        if ($sub_test_id) {
            $final_data[$package_id]['tests'][$test_id]['sub_tests'][] = [
                'id' => intval($sub_test_id),
                'name' => $row['sub_test_name']
            ];
        }
    }

    // Convert tests array from associative to indexed
    foreach ($final_data as &$package) {
        $package['tests'] = array_values($package['tests']);
    }

    return array_values($final_data);
}
/*diagnostics*/

/*main data*/
public function get_main_data_first($cat_id, $lat, $lon, $radius,$limit,$offset){
    $this->db->select("
        COALESCE(( 6371 * acos( cos( radians({$lat}) ) * cos( radians( `lat` ) ) * cos( radians( lon ) - radians({$lon}) ) + sin( radians({$lat}) ) * sin( radians( `lat` ) ) ) ), 0) AS distance, 
        main_data.id,main_data.cat_id,main_data.sub_cat_id,main_data.sub_sub_cat_id,main_data.name,main_data.tagline,main_data.logo,main_data.location,main_data.lat,main_data.lon", false);
    $this->db->from('main_data');
    
    // Filters
    $this->db->where('main_data.cat_id', $cat_id);
    $this->db->where('main_data.status', 1);
    $this->db->where('main_data.delete_status', 1);

    // Distance Filter
    $this->db->having('distance <=', $radius);

    // Grouping
    $this->db->group_by('main_data.id');
    $this->db->order_by('distance', 'asc');
    $this->db->limit($limit,$offset);
    $query = $this->db->get();
    $result = $query->result_array();

    
    return $result;
}
public function get_main_data_first_rows($cat_id, $lat, $lon, $radius){
    $this->db->select("
        COALESCE(( 6371 * acos( cos( radians({$lat}) ) * cos( radians( `lat` ) ) * cos( radians( lon ) - radians({$lon}) ) + sin( radians({$lat}) ) * sin( radians( `lat` ) ) ) ), 0) AS distance, 
        main_data.id,main_data.cat_id,main_data.name,main_data.tagline,main_data.logo,main_data.location,main_data.lat,main_data.lon", false);
    $this->db->from('main_data');
    
    // Filters
    $this->db->where('main_data.cat_id', $cat_id);
    $this->db->where('main_data.status', 1);
    $this->db->where('main_data.delete_status', 1);

    // Distance Filter
    $this->db->having('distance <=', $radius);

    // Grouping
    $this->db->group_by('main_data.id');
    $this->db->order_by('distance', 'asc');
    //$this->db->limit($limit,$offset);
    $query = $this->db->get();
    $result = $query->num_rows();

    
    return $result;
}
public function get_search_main_data_first($cat_id, $lat, $lon, $search, $radius) {
    $this->db->select("
        COALESCE(( 6371 * acos( cos( radians({$lat}) ) * cos( radians( `lat` ) ) * cos( radians( lon ) - radians({$lon}) ) + sin( radians({$lat}) ) * sin( radians( `lat` ) ) ) ), 0) AS distance, 
        main_data.id,main_data.cat_id,main_data.sub_cat_id,main_data.sub_sub_cat_id,main_data.name,main_data.tagline,main_data.logo,main_data.location,main_data.lat,main_data.lon", false);
    $this->db->from('main_data');
    
    // Filters
    $this->db->where('main_data.cat_id', $cat_id);
    $this->db->where('main_data.status', 1);
    $this->db->where('main_data.delete_status', 1);
    $this->db->like('main_data.name',$search);

    // Distance Filter
    $this->db->having('distance <=', $radius);

    // Grouping
    $this->db->group_by('main_data.id');
    $this->db->order_by('distance', 'asc');

    $query = $this->db->get();
    $result = $query->result_array();
    
    return $result;

}
public function get_main_data($cat_id, $lat, $lon, $radius, $main_data_id) {
    $this->db->select("
        COALESCE(( 6371 * acos( cos( radians({$lat}) ) * cos( radians( `lat` ) ) * cos( radians( lon ) - radians({$lon}) ) + sin( radians({$lat}) ) * sin( radians( `lat` ) ) ) ), 0) AS distance, 
        main_data.*, 
        GROUP_CONCAT(DISTINCT img.image) AS images,
        GROUP_CONCAT(DISTINCT CONCAT(specialities.id, '|', specialities.name, '|', specialities.image)) AS specialities
    ", false); 
    
    $this->db->from('main_data');
    
    // Join images table
    $this->db->join('images img', 'img.cat_id = main_data.cat_id AND img.main_data_id = main_data.id AND img.status=1 AND img.delete_status=1', 'left');
    $this->db->join('specialities specialities', 'specialities.cat_id = main_data.cat_id AND specialities.status=1 AND specialities.delete_status=1', 'left');

    // Filters
    $this->db->where('main_data.cat_id', $cat_id);
    $this->db->where('main_data.id', $main_data_id);
    $this->db->where('main_data.status', 1);
    $this->db->where('main_data.delete_status', 1);

    // Distance Filter
    $this->db->having('distance <=', $radius);

    // Grouping & Sorting
    $this->db->group_by('main_data.id');
    $this->db->order_by('distance', 'asc');

    $query = $this->db->get();
    $result = $query->result_array();

    // Process the results using array_map
    return array_map(function ($row) {
        return [
            'id'          => intval($row['id']),
            'name'        => $row['name'],
            'mobile'      => intval($row['mobile']),
            'tagline'     => $row['tagline'],
            'logo'        => $row['logo'],
            'open_time'   => $row['open_time'],
            'close_time'  => $row['close_time'],
            'location'    => $row['location'],
            'description' => $row['description'],
            'cat_id'      => intval($row['cat_id']),
            'sub_cat_id'      => intval($row['sub_cat_id']),
            'sub_sub_cat_id'      => intval($row['sub_sub_cat_id']),
            'lat'         => $row['lat'],
            'lon'         => $row['lon'],
            'images'      => (!empty($row['images']) && is_string($row['images']))
                ? array_map(function ($image) {
                    return ['url' => trim($image)];
                }, array_filter(explode(',', $row['images'])))
                : [],
            'specialities' => (!empty($row['specialities']) && is_string($row['specialities']))
                ? array_map(function ($speciality) {
                    list($id, $name, $image) = explode('|', $speciality);
                    return [
                        'id'    => intval($id),
                        'name'  => $name,
                        'image' => $image
                    ];
                }, array_filter(explode(',', $row['specialities'])))
                : [],
        ];
    }, $result);
}
public function get_doctors($cat_id, $main_data_id, $speciality_id) {
    $this->db->select('
        doctors.*, 
        SUM(doctor_ratings.rating) AS total_rating, 
        COUNT(doctor_ratings.id) AS total_reviews,
        main_data.location
    ')->from('doctors');

    $this->db->where([
        'doctors.cat_id' => $cat_id,
        'doctors.main_data_id' => $main_data_id,
        'doctors.speciality_id' => $speciality_id,
        'doctors.status' => 1,
        'doctors.delete_status' => 1
    ]);

    $this->db->join('doctor_ratings', 'doctor_ratings.cat_id = doctors.cat_id 
                                       AND doctor_ratings.main_data_id = doctors.main_data_id 
                                       AND doctor_ratings.doctor_id = doctors.id', 'left');
    $this->db->join('main_data',"main_data.id=$main_data_id",'left');
    
    $this->db->group_by('doctors.id');
    $this->db->order_by('doctors.id', 'desc');

    $query = $this->db->get();
    $result = $query->result_array(); 
    
    // Process the results using array_map
    return array_map(function ($row) {
        $total_rating = floatval($row['total_rating']);
        $total_reviews = intval($row['total_reviews']);
        $average_rating = ($total_reviews > 0) ? number_format($total_rating / $total_reviews, 1) : "0.0";

        return [
            'id'                => intval($row['id']),
            'unique_id'         => $row['unique_id'],
            'cat_id'            => intval($row['cat_id']),
            'sub_cat_id'        => intval($row['sub_cat_id']),
            'sub_sub_cat_id'    => intval($row['sub_sub_cat_id']),
            'main_data_id'      => intval($row['main_data_id']),
            'name'              => $row['name'],
            'image'             => $row['image'],
            'qualification'     => $row['qualification'],
            'specialization'    => $row['specialization'],
            'exp'               => $row['exp'],
            'description'       => $row['description'],
            'fee'               => intval($row['fee']),
            'consult_type'      => $row['consult_type'],
            'rating'            => $average_rating,
            'total_reviews'     => $total_reviews,
            'location'          => $row['location']
        ];
    }, $result);
}
public function filter_data($cat_id,$sub_cat_ids,$sub_sub_cat_ids,$radius,$lat,$lon,$limit, $offset){
    // Fetch data from `main_data`
    $this->db->select("
        COALESCE(( 6371 * acos( cos( radians({$lat}) ) * cos( radians( `lat` ) ) * cos( radians( lon ) - radians({$lon}) ) + sin( radians({$lat}) ) * sin( radians( `lat` ) ) ) ), 0) AS distance, 
        main_data.id,main_data.cat_id,main_data.sub_cat_id,main_data.sub_sub_cat_id,main_data.name,main_data.tagline,main_data.logo,main_data.location,main_data.lat,main_data.lon", false);
    $this->db->from('main_data');
    $this->db->where('main_data.cat_id', $cat_id);
    $this->db->where_in('main_data.sub_cat_id', $sub_cat_ids);

    // Apply `sub_sub_cat_id` filter if provided
    if (!empty($sub_sub_cat_ids)) {
        $this->db->where_in('main_data.sub_sub_cat_id', $sub_sub_cat_ids);
    }
    
    // Distance Filter
    $this->db->having('distance <=', $radius);
    
    // Grouping
    $this->db->group_by('main_data.id');
    $this->db->order_by('distance', 'asc');
    $this->db->limit($limit,$offset);
    $query = $this->db->get();
    $result = $query->result_array();

    
    return $result;
}
public function get_filter_data_rows($cat_id,$sub_cat_ids,$sub_sub_cat_ids,$radius,$lat,$lon){
    // Fetch data from `main_data`
    $this->db->select("
        COALESCE(( 6371 * acos( cos( radians({$lat}) ) * cos( radians( `lat` ) ) * cos( radians( lon ) - radians({$lon}) ) + sin( radians({$lat}) ) * sin( radians( `lat` ) ) ) ), 0) AS distance, 
        main_data.id,main_data.cat_id,main_data.name,main_data.tagline,main_data.logo,main_data.location,main_data.lat,main_data.lon", false);
    $this->db->from('main_data');
    $this->db->where('main_data.cat_id', $cat_id);
    $this->db->where_in('main_data.sub_cat_id', $sub_cat_ids);

    // Apply `sub_sub_cat_id` filter if provided
    if (!empty($sub_sub_cat_ids)) {
        $this->db->where_in('main_data.sub_sub_cat_id', $sub_sub_cat_ids);
    }
    
    // Distance Filter
    $this->db->having('distance <=', $radius);
    
    // Grouping
    $this->db->group_by('main_data.id');
    $this->db->order_by('distance', 'asc');
    $query = $this->db->get();
    $result = $query->num_rows();
    return $result;
}
public function get_sub_cat_main_data_first($sub_cat_id, $lat, $lon, $radius,$limit,$offset){
    $this->db->select("
        COALESCE(( 6371 * acos( cos( radians({$lat}) ) * cos( radians( `lat` ) ) * cos( radians( lon ) - radians({$lon}) ) + sin( radians({$lat}) ) * sin( radians( `lat` ) ) ) ), 0) AS distance, 
        main_data.id,main_data.cat_id,main_data.sub_cat_id,main_data.sub_sub_cat_id,main_data.name,main_data.tagline,main_data.logo,main_data.location,main_data.lat,main_data.lon", false);
    $this->db->from('main_data');
    
    // Filters
    $this->db->where('main_data.sub_cat_id', $sub_cat_id);
    $this->db->where('main_data.status', 1);
    $this->db->where('main_data.delete_status', 1);

    // Distance Filter
    $this->db->having('distance <=', $radius);

    // Grouping
    $this->db->group_by('main_data.id');
    $this->db->order_by('distance', 'asc');
    $this->db->limit($limit,$offset);
    $query = $this->db->get();
    $result = $query->result_array();

    
    return $result;
}
public function get_sub_cat_main_data_first_rows($sub_cat_id, $lat, $lon, $radius){
    $this->db->select("
        COALESCE(( 6371 * acos( cos( radians({$lat}) ) * cos( radians( `lat` ) ) * cos( radians( lon ) - radians({$lon}) ) + sin( radians({$lat}) ) * sin( radians( `lat` ) ) ) ), 0) AS distance, 
        main_data.id,main_data.cat_id,main_data.name,main_data.tagline,main_data.logo,main_data.location,main_data.lat,main_data.lon", false);
    $this->db->from('main_data');
    
    // Filters
    $this->db->where('main_data.sub_cat_id', $sub_cat_id);
    $this->db->where('main_data.status', 1);
    $this->db->where('main_data.delete_status', 1);

    // Distance Filter
    $this->db->having('distance <=', $radius);

    // Grouping
    $this->db->group_by('main_data.id');
    $this->db->order_by('distance', 'asc');
    //$this->db->limit($limit,$offset);
    $query = $this->db->get();
    $result = $query->num_rows();

    
    return $result;
}
public function get_search_sub_cat_main_data_first($sub_cat_id, $lat, $lon, $search, $radius) {
    $this->db->select("
        COALESCE(( 6371 * acos( cos( radians({$lat}) ) * cos( radians( `lat` ) ) * cos( radians( lon ) - radians({$lon}) ) + sin( radians({$lat}) ) * sin( radians( `lat` ) ) ) ), 0) AS distance, 
        main_data.id,main_data.cat_id,main_data.sub_cat_id,main_data.sub_sub_cat_id,main_data.name,main_data.tagline,main_data.logo,main_data.location,main_data.lat,main_data.lon", false);
    $this->db->from('main_data');
    
    // Filters
    $this->db->where('main_data.sub_cat_id', $sub_cat_id);
    $this->db->where('main_data.status', 1);
    $this->db->where('main_data.delete_status', 1);
    $this->db->like('main_data.name',$search);

    // Distance Filter
    $this->db->having('distance <=', $radius);

    // Grouping
    $this->db->group_by('main_data.id');
    $this->db->order_by('distance', 'asc');

    $query = $this->db->get();
    $result = $query->result_array();
    
    return $result;

}
public function get_all_hospitals_first($cat_id, $lat, $lon, $radius,$limit,$offset){
    $this->db->select("
        COALESCE(( 6371 * acos( cos( radians({$lat}) ) * cos( radians( `lat` ) ) * cos( radians( lon ) - radians({$lon}) ) + sin( radians({$lat}) ) * sin( radians( `lat` ) ) ) ), 0) AS distance, 
        main_data.id,main_data.cat_id,main_data.sub_cat_id,main_data.sub_sub_cat_id,main_data.name,main_data.tagline,main_data.logo,main_data.location,main_data.lat,main_data.lon", false);
    $this->db->from('main_data');
    
    // Filters
    $this->db->where('main_data.status', 1);
    $this->db->where('main_data.delete_status', 1);

    // Distance Filter
    $this->db->having('distance <=', $radius);

    // Grouping
    $this->db->group_by('main_data.id');
    $this->db->order_by('distance', 'asc');
    $this->db->limit($limit,$offset);
    $query = $this->db->get();
    $result = $query->result_array();
    
    return $result;
}
public function get_all_hospitals_first_rows($cat_id, $lat, $lon, $radius){
    $this->db->select("
        COALESCE(( 6371 * acos( cos( radians({$lat}) ) * cos( radians( `lat` ) ) * cos( radians( lon ) - radians({$lon}) ) + sin( radians({$lat}) ) * sin( radians( `lat` ) ) ) ), 0) AS distance, 
        main_data.id,main_data.cat_id,main_data.name,main_data.tagline,main_data.logo,main_data.location,main_data.lat,main_data.lon", false);
    $this->db->from('main_data');
    
    // Filters
    $this->db->where('main_data.status', 1);
    $this->db->where('main_data.delete_status', 1);

    // Distance Filter
    $this->db->having('distance <=', $radius);

    // Grouping
    $this->db->group_by('main_data.id');
    $this->db->order_by('distance', 'asc');
    //$this->db->limit($limit,$offset);
    $query = $this->db->get();
    $result = $query->num_rows();

    return $result;
}
public function get_search_all_hospitals_first($cat_id, $lat, $lon, $search, $radius) {
    $this->db->select("
        COALESCE(( 6371 * acos( cos( radians({$lat}) ) * cos( radians( `lat` ) ) * cos( radians( lon ) - radians({$lon}) ) + sin( radians({$lat}) ) * sin( radians( `lat` ) ) ) ), 0) AS distance, 
        main_data.id,main_data.cat_id,main_data.sub_cat_id,main_data.sub_sub_cat_id,main_data.name,main_data.tagline,main_data.logo,main_data.location,main_data.lat,main_data.lon", false);
    $this->db->from('main_data');
    
    // Filters
    $this->db->where('main_data.status', 1);
    $this->db->where('main_data.delete_status', 1);
    $this->db->like('main_data.name',$search);

    // Distance Filter
    $this->db->having('distance <=', $radius);

    // Grouping
    $this->db->group_by('main_data.id');
    $this->db->order_by('distance', 'asc');

    $query = $this->db->get();
    $result = $query->result_array();
    
    return $result;
}
/*main data*/

/*hospital_bookings*/
public function get_admit_slots($cat_id,$main_data_id,$date,$user_id){
    // Fetch doctor slots
    $this->db->select('id, time, session, status, date');
    $this->db->from('admit_slots');
    $this->db->where('cat_id', $cat_id);
    $this->db->where('main_data_id', $main_data_id);
    $this->db->where('date', $date);
    $this->db->order_by('time', 'ASC');

    $query = $this->db->get();
    $results = $query->result_array();

    // Group slots by session
    $slots = ['morning' => [], 'afternoon' => [], 'evening' => []];
    foreach ($results as $row) {
        $row['id']          = intval($row['id']); // Convert slot ID to int
        $row['format_date'] = date('d M Y', strtotime($row['date']));
        $slots[$row['session']][] = $row;
    }

    // Fetch family members separately
    $this->db->select('id, name, type');
    $this->db->from('family_members');
    $this->db->where('user_id', $user_id);  // Fetch family members of the logged-in user
    $family_query = $this->db->get();
    $family_members = $family_query->result_array();

    // Convert family member IDs to integers
    foreach ($family_members as &$member) {
        $member['id'] = intval($member['id']);  // Ensure id is an integer
    }

    // Return both doctor slots and family members in a single response
    return [
        'slots' => $slots,
        'family_members' => $family_members
    ];
}
public function get_doctor_slots($cat_id, $main_data_id, $doctor_id, $date, $user_id){
    // Fetch doctor slots
    $this->db->select('id, time, session, status, date');
    $this->db->from('doctor_slots');
    $this->db->where('cat_id', $cat_id);
    $this->db->where('main_data_id', $main_data_id);
    $this->db->where('doctor_id', $doctor_id);
    $this->db->where('date', $date);
    $this->db->order_by('time', 'ASC');

    $query = $this->db->get();
    $results = $query->result_array();

    // Group slots by session
    $slots = ['morning' => [], 'afternoon' => [], 'evening' => []];
    foreach ($results as $row) {
        $row['id']          = intval($row['id']); // Convert slot ID to int
        $row['format_date'] = date('d M Y', strtotime($row['date']));
        $slots[$row['session']][] = $row;
    }

    // Fetch family members separately
    $this->db->select('id, name, type');
    $this->db->from('family_members');
    $this->db->where('user_id', $user_id);  // Fetch family members of the logged-in user
    $family_query = $this->db->get();
    $family_members = $family_query->result_array();

    // Convert family member IDs to integers
    foreach ($family_members as &$member) {
        $member['id'] = intval($member['id']);  // Ensure id is an integer
    }

    // Return both doctor slots and family members in a single response
    return [
        'slots' => $slots,
        'family_members' => $family_members
    ];
}
/*hospital_bookings*/

/*health cards*/
public function get_health_cards($user_id){
    $this->db->select('health_card_holders.*,family_members.name as family_members_name,family_members.image as family_members_image,family_members.type')->from('health_card_holders');
    $this->db->where('health_card_holders.user_id',$user_id);
    $this->db->join('family_members','family_members.id=health_card_holders.family_id','left');
    $query = $this->db->get();
    return $query->result_array();
}
/*health cards*/

/*offers*/
public function get_main_data_offers($lat, $lon, $radius) {
    $this->db->select("
        COALESCE(( 6371 * acos( cos( radians({$lat}) ) * cos( radians( `lat` ) ) * cos( radians( lon ) - radians({$lon}) ) + sin( radians({$lat}) ) * sin( radians( `lat` ) ) ) ), 0) AS distance, 
        main_data.id,main_data.cat_id,main_data.name,main_data.tagline,main_data.logo,main_data.location,main_data.lat,main_data.lon", false);
    $this->db->from('main_data');
    

    // Filters
    $this->db->where('main_data.offers', 'yes');
    $this->db->where('main_data.status', 1);
    $this->db->where('main_data.delete_status', 1);

    // Distance Filter
    $this->db->having('distance <=', $radius);

    // Grouping
    $this->db->group_by('main_data.id');
    $this->db->order_by('distance', 'asc');

    $query = $this->db->get();
    $result = $query->result_array();
    
    
    return $result;

}

public function get_search_main_data_offers($lat, $lon, $search, $radius) {
    $this->db->select("
        COALESCE(( 6371 * acos( cos( radians({$lat}) ) * cos( radians( `lat` ) ) * cos( radians( lon ) - radians({$lon}) ) + sin( radians({$lat}) ) * sin( radians( `lat` ) ) ) ), 0) AS distance, 
       main_data.id,main_data.cat_id,main_data.name,main_data.tagline,main_data.logo,main_data.location,main_data.lat,main_data.lon", false);
    $this->db->from('main_data');
    

    // Filters
    $this->db->where('main_data.offers', 'yes');
    $this->db->where('main_data.status', 1);
    $this->db->where('main_data.delete_status', 1);
    $this->db->like('main_data.name',$search);

    // Distance Filter
    $this->db->having('distance <=', $radius);

    // Grouping
    $this->db->group_by('main_data.id');
    $this->db->order_by('distance', 'asc');

    $query = $this->db->get();
    $result = $query->result_array();
    
    
    return $result;

}
/*offers*/

/*executive_app_apis*/
public function executive_sales($executive_id){
    $this->db->select('executive_sales_completed.*,users.id as user_id,users.name,users.image,users.gender,users.mobile,executives.executive_id as unique_id')->from('executive_sales_completed');
    $this->db->where('executive_sales_completed.executive_id',$executive_id);
    $this->db->join('users','users.id=executive_sales_completed.user_id','left');
    $this->db->join('executives','executives.id=executive_sales_completed.executive_id','left');
    $query = $this->db->get();
    $result = $query->result_array();
    return $result;
}
public function search_executive_sales($search, $executive_id) {
    $this->db->select('executive_sales_completed.*, users.name, users.image, users.gender, users.mobile, executives.executive_id as unique_id');
    $this->db->from('executive_sales_completed');
    $this->db->join('users', 'users.id = executive_sales_completed.user_id', 'left');
    $this->db->join('executives', 'executives.id = executive_sales_completed.executive_id', 'left');

    // Add search condition for the users.name column
    $this->db->like('users.name', $search);

    // Add condition for executive_id
    $this->db->where('executive_sales_completed.executive_id', $executive_id);

    $query = $this->db->get();
    $result = $query->result_array();
    return $result;
}

/*executive_app_apis*/

}
?>