<?php
class Registermodel extends CI_Model{
/*default functions*/
public function common_fetch($table,$where){
	$this->db->where($where);
	$this->db->order_by('id','desc');
	$query = $this->db->get($table);
	return $query->result_array();
}
public function common_fetch_asc($table,$where){
	$this->db->where($where);
	$this->db->order_by('id','asc');
	$query = $this->db->get($table);
	return $query->result_array();
}
public function common_fetch_rows($table,$where){
	$this->db->where($where);
	$this->db->order_by('id','desc');
	$query = $this->db->get($table);
	return $query->num_rows();
}
public function common_insert($table,$data){
	$this->db->insert($table,$data);
	$id = $this->db->insert_id();
	return $id;
}
public function common_update($table,$data,$where){
	$this->db->where($where);
	$this->db->update($table,$data);
}
public function common_delete($table,$where){
	$this->db->where($where);
	$this->db->delete($table);
}
/*default functions*/

/*public_relation_agents*/
public function get_public_relation_agents($sess_data,$limit,$start,$search){
    $this->db->where(['main_data_id' => $sess_data,'delete_status' => 1]);
    if(!empty($search)){
        $this->db->group_start();
        $this->db->like('name',$search);
        $this->db->or_like('mobile',$search);
        $this->db->group_end();
    }
    $this->db->limit($limit,$start);
    $query = $this->db->get('public_relation_agents');
    return $query->result_array();
}
public function get_public_relation_agents_count($sess_data,$search){
    $this->db->where(['main_data_id' => $sess_data,'delete_status' => 1]);
    if(!empty($search)){
        $this->db->group_start();
        $this->db->like('name',$search);
        $this->db->or_like('mobile',$search);
        $this->db->group_end();
    }
    $query = $this->db->get('public_relation_agents');
    return $query->num_rows();
}
/*public_relation_agents*/

/*ambulances*/
public function get_ambulances($sess_data,$limit,$start,$search){
    $this->db->where(['main_data_id' => $sess_data,'delete_status' => 1]);
    if(!empty($search)){
        $this->db->group_start();
        $this->db->like('name',$search);
        $this->db->or_like('mobile',$search);
        $this->db->or_like('reg_number',$search);
        $this->db->group_end();
    }
    $this->db->limit($limit,$start);
    $query = $this->db->get('ambulances');
    return $query->result_array();
}
public function get_ambulances_count($sess_data,$search){
    $this->db->where(['main_data_id' => $sess_data,'delete_status' => 1]);
    if(!empty($search)){
        $this->db->group_start();
        $this->db->like('name',$search);
        $this->db->or_like('mobile',$search);
        $this->db->or_like('reg_number',$search);
        $this->db->group_end();
    }
    $query = $this->db->get('ambulances');
    return $query->num_rows();
}
/*ambulances*/

/*doctors*/
public function get_doctors($sess_data,$limit,$start,$search){
    $this->db->select('doctors.*,specialities.name as speciality')->from('doctors');
    $this->db->where(['doctors.main_data_id' => $sess_data,'doctors.delete_status' => 1]);
    if(!empty($search)){
        $this->db->group_start();
        $this->db->like('doctors.name',$search);
        $this->db->or_like('specialities.name',$search);
        $this->db->or_like('doctors.consult_type',$search);
        $this->db->group_end();
    }
    $this->db->join('specialities','specialities.id=doctors.speciality_id','left');
    $this->db->limit($limit,$start);
    $query = $this->db->get();
    return $query->result_array();
}
public function get_doctors_count($sess_data,$search){
    $this->db->select('doctors.*,specialities.name as speciality')->from('doctors');
    $this->db->where(['doctors.main_data_id' => $sess_data,'doctors.delete_status' => 1]);
    if(!empty($search)){
        $this->db->group_start();
        $this->db->like('doctors.name',$search);
        $this->db->or_like('specialities.name',$search);
        $this->db->or_like('doctors.consult_type',$search);
        $this->db->group_end();
    }
    $this->db->join('specialities','specialities.id=doctors.speciality_id','left');
    $query = $this->db->get();
    return $query->num_rows();
}
public function get_doctor_slots($sess_data, $limit, $start, $search) {
    $this->db->select('doctor_slots.date, doctors.name, doctor_slots.id, doctor_slots.doctor_id,doctor_slots.created_on,doctor_slots.modified_on')
             ->from('doctor_slots')
             ->where(['doctor_slots.main_data_id' => $sess_data, 'doctor_slots.delete_status' => 1]);

    if (!empty($search)) {
        $this->db->group_start();
        $this->db->like('doctors.name', $search);
        $this->db->or_like('doctor_slots.date', $search);
        $this->db->group_end();
    }

    $this->db->join('doctors', 'doctors.id = doctor_slots.doctor_id AND doctors.status = 1 AND doctors.delete_status = 1', 'left');
    $this->db->group_by(['doctor_slots.date', 'doctor_slots.doctor_id']); // Grouping by date & doctor_id
    $this->db->limit($limit, $start);

    $query = $this->db->get();
    return $query->result_array();
}

public function get_doctor_slots_count($sess_data,$search){
    $this->db->select('doctor_slots.date, doctors.name, doctor_slots.id, doctor_slots.doctor_id,doctor_slots.created_on,doctor_slots.modified_on')
             ->from('doctor_slots')
             ->where(['doctor_slots.main_data_id' => $sess_data, 'doctor_slots.delete_status' => 1]);

    if (!empty($search)) {
        $this->db->group_start();
        $this->db->like('doctors.name', $search);
        $this->db->or_like('doctor_slots.date', $search);
        $this->db->group_end();
    }

    $this->db->join('doctors', 'doctors.id = doctor_slots.doctor_id AND doctors.status = 1 AND doctors.delete_status = 1', 'left');
    $this->db->group_by(['doctor_slots.date', 'doctor_slots.doctor_id']); // Grouping by date & doctor_id

    $query = $this->db->get();
    return $query->num_rows();
}
/*doctors*/

/*pharmacy*/
public function get_pharmacy($sess_data,$limit,$start,$search){
    $this->db->select('hospital_pharmacy_products.*,pharmacy_categories.name as category')->from('hospital_pharmacy_products');
    $this->db->where(['hospital_pharmacy_products.main_data_id' => $sess_data,'hospital_pharmacy_products.delete_status' => 1]);
    if(!empty($search)){
        $this->db->group_start();
        $this->db->like('hospital_pharmacy_products.name',$search);
        $this->db->or_like('pharmacy_categ.name',$search);
        $this->db->or_like('doctors.consult_type',$search);
        $this->db->group_end();
    }
    $this->db->join('specialities','specialities.id=doctors.speciality_id','left');
    $this->db->limit($limit,$start);
    $query = $this->db->get();
    return $query->result_array();
}
public function get_pharmacy_count($sess_data,$search){
    $this->db->select('doctors.*,specialities.name as speciality')->from('doctors');
    $this->db->where(['doctors.main_data_id' => $sess_data,'doctors.delete_status' => 1]);
    if(!empty($search)){
        $this->db->group_start();
        $this->db->like('doctors.name',$search);
        $this->db->or_like('specialities.name',$search);
        $this->db->or_like('doctors.consult_type',$search);
        $this->db->group_end();
    }
    $this->db->join('specialities','specialities.id=doctors.speciality_id','left');
    $query = $this->db->get();
    return $query->num_rows();
}
/*pharmacy*/

}
?>