<style>
    /* Hide default checkbox */
    input[type="checkbox"] {
        appearance: none;
        width: 20px;
        height: 20px;
        border: 2px solid #4CAF50; /* Green border for available */
        border-radius: 5px;
        cursor: pointer;
        position: relative;
    }

    /* Available slot checkbox (Green) */
    input[type="checkbox"]:checked {
        background-color: #4CAF50; /* Green when selected */
    }

    /* Booked slot checkbox (Red, Disabled) */
    input[type="checkbox"].booked {
        background-color: #ff4d4d !important; /* Red */
        border-color: #ff4d4d !important;
        cursor: not-allowed;
    }

    /* Disable hover effect for booked slots */
    input[type="checkbox"].booked:hover {
        opacity: 1;
    }
</style>

<?php
$date = $doctor_slot[0]['date']; // Selected date
$doctor_id = $doctor_slot[0]['doctor_id'];
$id = $doctor_slot[0]['id'];
// Fetch all previously selected slots with their booking status
$existing_slots = $this->registermodel->common_fetch('doctor_slots', [
    'doctor_id' => $doctor_id,
    'date' => $date,
    'delete_status' => 1
]);

// Convert to an associative array (time => booking_status)
$slot_status = [];
foreach ($existing_slots as $slot) {
    $slot_status[$slot['time']] = $slot['booking_status']; // 1 = Booked, 0 = Available
}
?>

<div class="container-xxl flex-grow-1 container-p-y">
              <h4 class="py-3 mb-4"><span class="text-muted fw-light">Edit Doctor Slots</h4>
              
  <div class="row"><div class="col-md-6">
      <div class="card mb-4">
          <form method="post" action="#" id="inputform" enctype="multipart/form-data">
        <div class="card-body">
            
            <div class="mb-3">
            <label for="exampleFormControlInput1" class="form-label">Doctor *</label>
            <select class="form-select" name="doctor_id" required placeholder="Doctor" disabled>
                <option value="">Select Doctor</option>
                <?php if(!empty($doctors)){ 
                foreach($doctors as $row){?>
                <option value="<?=$row['id']?>" <?php if($row['id']==$doctor_slot[0]['doctor_id']){echo 'selected="selected"';}?>><?=$row['name']?></option>
                <?php } } ?>
            </select>
          </div>
            
          <div class="mb-3">
            <label for="exampleFormControlInput1" class="form-label">Date *</label>
            <input
              type="date"
              class="form-control"
              id="dateInput"
              placeholder="Date" name="date" required value="<?=$doctor_slot[0]['date']?>" disabled/>
          </div>
         
         <div class="mb-3">
            <label for="exampleFormControlInput1" class="form-label">Time Slots *</label>
        
            <div class="mb-3">
                <strong>Morning</strong><br>
                <?php foreach ($slots['morning'] as $morning) { 
                    $is_booked = isset($slot_status[$morning['time']]) && $slot_status[$morning['time']] == "booked";
                    $checkbox_class = $is_booked ? 'booked' : ''; // Add class for booked slots
                    ?>
                    <label>
                        <input type="checkbox" class="time-slot <?= $checkbox_class ?>" name="time[]" value="<?= $morning['time'] ?>" 
                            class="<?= $checkbox_class; ?>"
                            <?= isset($slot_status[$morning['time']]) ? 'checked' : '' ?> 
                            <?= $is_booked ? 'disabled' : '' ?>>
                        <?= $morning['time'] ?>
                    </label>
                <?php } ?>
            </div>
        
            <div class="mb-3">
                <strong>Afternoon</strong><br>
                <?php foreach ($slots['afternoon'] as $afternoon) { 
                    $is_booked = isset($slot_status[$afternoon['time']]) && $slot_status[$afternoon['time']] == "booked";
                    $checkbox_class = $is_booked ? 'booked' : '';
                    ?>
                    <label>
                        <input type="checkbox" name="time[]" class="time-slot <?= $checkbox_class ?>" value="<?= $afternoon['time'] ?>" 
                            class="<?= $checkbox_class; ?>"
                            <?= isset($slot_status[$afternoon['time']]) ? 'checked' : '' ?> 
                            <?= $is_booked ? 'disabled' : '' ?>>
                        <?= $afternoon['time'] ?>
                    </label>
                <?php } ?>
            </div>
        
            <div class="mb-3">
                <strong>Evening</strong><br>
                <?php foreach ($slots['evening'] as $evening) { 
                    $is_booked = isset($slot_status[$evening['time']]) && $slot_status[$evening['time']] == "booked";
                    $checkbox_class = $is_booked ? 'booked' : '';
                    ?>
                    <label>
                        <input type="checkbox" class="time-slot <?= $checkbox_class ?>" name="time[]" value="<?= $evening['time'] ?>" 
                            class="<?= $checkbox_class; ?>"
                            <?= isset($slot_status[$evening['time']]) ? 'checked' : '' ?> 
                            <?= $is_booked ? 'disabled' : '' ?>>
                        <?= $evening['time'] ?>
                    </label>
                <?php } ?>
            </div>
        </div>
            <div class="mb-3">
                <strong>Legend:</strong><br>
                <label>
                    <input type="checkbox" disabled style="background-color: #ff4d4d; border-color: #ff4d4d;"> 
                    <span>Booked (Cannot Uncheck)</span>
                </label><br>
            
                <label>
                    <input type="checkbox" checked disabled style="background-color: #4CAF50; border-color: #4CAF50;"> 
                    <span>Previously Selected (Can Uncheck)</span>
                </label><br>
            
                <label>
                    <input type="checkbox" disabled style="border: 2px solid #4CAF50;"> 
                    <span>Available (Can Select)</span>
                </label>
            </div>
        </div>
      </div>
       <!--<button type="button" name="sub" value="sub" class="btn btn-success" id="saveBtn">Submit</button>-->
      </form>
      <a href="<?=base_url('hospitals/register/doctor_slots')?>"><button type="button" class="btn btn-danger">Cancel</button></a>
    </div></div>
</div>

<script>
    // Set today's date as the minimum selectable date
    document.addEventListener("DOMContentLoaded", function () {
        let today = new Date().toISOString().split('T')[0]; // Format YYYY-MM-DD
        document.getElementById("dateInput").setAttribute("min", today);
    });
</script>

<script>
$(document).ready(function () {
    $(".time-slot").on("change", function () {
        var id     = "<?= $id ?>";
        var doctor_id = "<?= $doctor_id ?>"; // Get the doctor ID
        var date = "<?= $date ?>"; // Get the selected date
        var time = $(this).val(); // Get the selected time slot
        var isChecked = $(this).prop("checked") ? 1 : 0; // 1 = Add, 0 = Remove

        $.ajax({
            url: "<?= base_url('hospitals/register/edit_doctor_slot_data') ?>", // Your controller function
            type: "POST",
            data: { doctor_id: doctor_id, date: date, time: time, status: isChecked, id:id},
            success: function (response) {
                const res = JSON.parse(response);
                if (res.success) {
                    showToast('Success', res.message, 'success');
                } else {
                    showToast('Error', res.message, 'error');
                }
            }
        });
    });
});

</script>

<!-- Toastr CSS -->
<link href="https://cdnjs.cloudflare.com/ajax/libs/toastr.js/latest/toastr.min.css" rel="stylesheet">
<!-- Toastr JS -->
<script src="https://cdnjs.cloudflare.com/ajax/libs/toastr.js/latest/toastr.min.js"></script>


<script>
// Show toast using jQuery
function showToast(title, message, type) {
    toastr.options = {
        closeButton: true,
        progressBar: true,
        positionClass: "toast-top-right",
        timeOut: "3000",
    };

    if (type === 'success') {
        toastr.success(message, title);
    } else if (type === 'error') {
        toastr.error(message, title);
    } else if (type === 'info') {
        toastr.info(message, title);
    } else if (type === 'warning') {
        toastr.warning(message, title);
    }
}


</script>
            